/********************************************************************
*==================  		ЗАО "ННН"		========================*
*********************************************************************/
/*!
* \file				main.cpp
* \brief			Пример использования класса YStdDelegate
* \framework{		Qt 4.3.4}
* \compiller{		GCC (MinGW32-gcc rev3.4.5)}
* \date				6.04.2008	8.04.2008
* \author			Литкевич Юрий Иванович
*/
/*
* Support E-mail:	lit-uriy@yandex.ru
* Лицензия:			GNU GPLv2
* TabSize:			4
* Encodding:		UTF-8 (w/o BOM)	
*						 
* 							
* 		 					
* 							
* Log:
* Date				Athor				Description
* 
*
********************************************************************/


#include <QApplication>
#include <QTextCodec>
#include <QtGui/QStyleFactory>
#include <QtGui/QStyle>
#include <QStandardItemModel>
#include <QTableView>

 
#include "ystddelegate.h"

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
	
	// Установим кодировку для функции перевода tr()
	QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));
	
	// Сделаем симпотичный вид
	QStyle *pStyle = QStyleFactory::create("Plastique");//Cleanlooks
	QApplication::setStyle(pStyle); //
	app.setPalette(pStyle->standardPalette());	
	
	// Создадим табличную модель 2 столца, 4 строки
    QStandardItemModel model(4, 2);
	
	// Создадим табличное представление
	// и установим для него модель
    QTableView tableView;
    tableView.setModel(&model);
	
	// создадим делегаты разных типов
    YStdDelegate delegate(YStdDelegate::TQSpinBox);
	YStdDelegate booldelegate(YStdDelegate::TBool);
	YStdDelegate datedelegate(YStdDelegate::TQDateTimeEdit);
	
	// Заполним модель данными
    for (int row = 0; row < 4; row++)
	{
		// создаем строчки
        for (int column = 0; column < 2; column++)
		{
			// создаем колонки
            QModelIndex index = model.index(row, column, QModelIndex());
			model.setData(index, QVariant((row) + (column)));//
        }
    }
	
	// Установим делегаты для представления
    tableView.setItemDelegate(&delegate);	// Для всех ячеек SpinBox
	tableView.setItemDelegateForRow(0, &booldelegate);// переопределим для первой строчки->булевый
	tableView.setItemDelegateForRow(1, &datedelegate);// переопределим для второй строчки->дата и время
	
	// Установим заголовок окна
    tableView.setWindowTitle(QObject::tr("Стандартные делегаты"));
	
	// Отобразим представление
    tableView.show();
    return app.exec();
}
